VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cClndFunc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Enum EnumCalendarDays
   cdWeiberfastnacht
   cdKarnevalsfreitag
   cdKarnevalssamstag
   cdKarnevalssonntag
   cdRosenmontag
   cdMardiGras
   cdAshWendsday
   cdGruenDonnerstag
   cdGoodFriday
   cdEasterSaturday
   cdEasterSunday
   cdEasterMonday
   cdAscension
   cdPentecost
   cdPentecostMonday
   cdCorpusChristi
   cdBussUndBettag
   cdAdvent1
   cdAdvent2
   cdAdvent3
   cdAdvent4
End Enum

Public Enum EnumFixDays
   fdNeujahr
   fd3Koenig
   fdTdArbeit
   fdTdDtEinheitAlt
   fdMariaHimmelfahrt
   fdTdDtEinheitNeu
   fdAllerheiligen
   fdHeiligabend
   fdWeihnachten
   fdWeihnachten2
   fdSilvester
End Enum

Public Enum EnumValid
   vaGeneral
   vaPartiell
   vaJahresabhaengig
   vaInofiziell = 5
   vaSonst = 9
End Enum

Private Const mc_NumOfDays  As Integer = 20  'hchster Index fr bewegliche Feiertage
Private Const mc_NumOfFix   As Integer = 10  'hchster Inderx fr feste Feiertage
Private Const mc_MinYear    As Integer = 1583
Private Const mc_MaxYear    As Integer = 4099
Private Const mc_FormatDay  As String = "dd. mmm"

Dim m_Year   As Integer       'aktuelles Jahr (zwischen mc_MinYear und mc_MaxYear)
Dim m_Easter As Date          'Osterdatum im aktuellen Jahr
Dim m_Advent As Date          'Datum des 1. Advent im aktuellen Jahr
Dim m_Days(mc_NumOfDays)        As Date
Dim m_NamesOfDays(mc_NumOfDays) As String
Dim m_NamesOfFix(mc_NumOfFix)   As String
Dim m_DaysDiff(mc_NumOfDays)    As Integer
Dim m_Level(mc_NumOfDays)       As EnumValid
Dim m_LevelFix(mc_NumOfFix)     As EnumValid

Private Sub Class_Initialize()
'bewegliche Feiertage
   m_NamesOfDays(cdWeiberfastnacht) = "Weiberfastnacht"
   m_NamesOfDays(cdKarnevalsfreitag) = "Karnevalsfreitag"
   m_NamesOfDays(cdKarnevalssamstag) = "Karnevalssamstag"
   m_NamesOfDays(cdKarnevalssonntag) = "Karnevalssonntag"
   m_NamesOfDays(cdRosenmontag) = "Rosenmontag"
   m_NamesOfDays(cdMardiGras) = "Fastnachtsdienstag"
   m_NamesOfDays(cdAshWendsday) = "Aschermittwoch"
   m_NamesOfDays(cdGruenDonnerstag) = "Grndonnerstag"
   m_NamesOfDays(cdGoodFriday) = "Karfreitag"
   m_NamesOfDays(cdEasterSaturday) = "Karsamstag"
   m_NamesOfDays(cdEasterSunday) = "Ostern"
   m_NamesOfDays(cdEasterMonday) = "Ostermontag"
   m_NamesOfDays(cdAscension) = "Himmelfahrt"
   m_NamesOfDays(cdPentecost) = "Pfingsten"
   m_NamesOfDays(cdPentecostMonday) = "Pfingstmontag"
   m_NamesOfDays(cdCorpusChristi) = "Fronleichnam"
   m_NamesOfDays(cdBussUndBettag) = "Bu- und Bettag"
   m_NamesOfDays(cdAdvent1) = "1. Advent"
   m_NamesOfDays(cdAdvent2) = "2. Advent"
   m_NamesOfDays(cdAdvent3) = "3. Advent"
   m_NamesOfDays(cdAdvent4) = "4. Advent"
   
   m_DaysDiff(cdWeiberfastnacht) = -52
   m_DaysDiff(cdKarnevalsfreitag) = -51
   m_DaysDiff(cdKarnevalssamstag) = -50
   m_DaysDiff(cdKarnevalssonntag) = -49
   m_DaysDiff(cdRosenmontag) = -48
   m_DaysDiff(cdMardiGras) = -47
   m_DaysDiff(cdAshWendsday) = -46
   m_DaysDiff(cdGruenDonnerstag) = -3
   m_DaysDiff(cdGoodFriday) = -2
   m_DaysDiff(cdEasterSaturday) = -1
   m_DaysDiff(cdEasterSunday) = 0
   m_DaysDiff(cdEasterMonday) = 1
   m_DaysDiff(cdAscension) = 39
   m_DaysDiff(cdPentecost) = 49
   m_DaysDiff(cdPentecostMonday) = 50
   m_DaysDiff(cdCorpusChristi) = 60
   m_DaysDiff(cdBussUndBettag) = -11
   m_DaysDiff(cdAdvent1) = 0
   m_DaysDiff(cdAdvent2) = 7
   m_DaysDiff(cdAdvent3) = 14
   m_DaysDiff(cdAdvent4) = 21
   
   m_Level(cdWeiberfastnacht) = vaInofiziell
   m_Level(cdKarnevalsfreitag) = vaSonst
   m_Level(cdKarnevalssamstag) = vaSonst
   m_Level(cdKarnevalssonntag) = vaSonst
   m_Level(cdRosenmontag) = vaPartiell
   m_Level(cdMardiGras) = vaInofiziell
   m_Level(cdAshWendsday) = vaInofiziell
   m_Level(cdGruenDonnerstag) = vaSonst
   m_Level(cdEasterSaturday) = vaSonst
   m_Level(cdBussUndBettag) = vaPartiell

'feste Feiertage
   m_NamesOfFix(fdNeujahr) = "Neujahr"
   m_NamesOfFix(fd3Koenig) = "Dreiknig"
   m_NamesOfFix(fdTdArbeit) = "Tag der Arbeit (1. Mai)"
   m_NamesOfFix(fdTdDtEinheitAlt) = "Tag der Deutschen Einheit (bis 1990)"
   m_NamesOfFix(fdMariaHimmelfahrt) = "Mari Himmelfahrt"
   m_NamesOfFix(fdTdDtEinheitNeu) = "Tag der Deutschen Einheit (ab 1991)"
   m_NamesOfFix(fdAllerheiligen) = "Allerheiligen"
   m_NamesOfFix(fdHeiligabend) = "Heiligabend"
   m_NamesOfFix(fdWeihnachten) = "1. Weihnachtstag"
   m_NamesOfFix(fdWeihnachten2) = "2. Weihnachtstag"
   m_NamesOfFix(fdSilvester) = "Silvester"

   m_LevelFix(fd3Koenig) = vaPartiell
   m_LevelFix(fdMariaHimmelfahrt) = vaPartiell
   m_LevelFix(fdTdDtEinheitAlt) = vaJahresabhaengig
   m_LevelFix(fdTdDtEinheitNeu) = vaJahresabhaengig
   m_LevelFix(fdHeiligabend) = vaInofiziell
   m_LevelFix(fdSilvester) = vaInofiziell
End Sub

Public Property Get NumberOfHolidays() As Integer
   NumberOfHolidays = mc_NumOfDays
End Property

Public Property Get NumberOfFixDays() As Integer
   NumberOfFixDays = mc_NumOfFix
End Property

Public Property Get MinYear() As Integer
   MinYear = mc_MinYear
End Property

Public Property Get MaxYear() As Integer
   MaxYear = mc_MaxYear
End Property

Public Property Get Year() As Integer
   Year = m_Year
End Property

'Initialze Year, calculate calendar days
Public Property Let Year(ByVal NewValue As Integer)
   Dim i As Integer
   
   If NewValue < mc_MinYear Or NewValue > mc_MaxYear Then
      m_Year = 0
      Exit Property
   End If
   
   m_Year = NewValue
   m_Easter = EasterDate(m_Year)
   m_Advent = AdventDate(m_Year)
   
   For i = 0 To cdBussUndBettag - 1
      m_Days(i) = m_Easter + m_DaysDiff(i)
   Next
   For i = cdBussUndBettag To mc_NumOfDays
      m_Days(i) = m_Advent + m_DaysDiff(i)
   Next
End Property

Public Property Get YearFormat() As String
   Dim sYear As String
   
   sYear = Format$(m_Year)
   If LeapYear Then
      sYear = sYear & "*"
   End If
   YearFormat = sYear
End Property

Public Property Get Invalid() As Boolean
   Invalid = (m_Year = 0)
End Property

Public Property Get LeapYear() As Boolean
   LeapYear = ((m_Year Mod 4 = 0 And m_Year Mod 100 <> 0) Or m_Year Mod 400 = 0)
End Property

Public Function DateOfFix(ByVal f As EnumFixDays, Y As Integer) As Date
   Dim d As Byte
   Dim m As Byte
   
   If Y < mc_MinYear Or Y > mc_MaxYear Then Exit Function

   Select Case f
   Case fdNeujahr
      d = 1
      m = 1
   Case fdTdArbeit
      d = 1
      m = 5
   Case fdTdDtEinheitAlt
      d = 17
      m = 6
   Case fdTdDtEinheitNeu
      d = 3
      m = 10
   Case fd3Koenig
      d = 6
      m = 1
   Case fdMariaHimmelfahrt
      d = 15
      m = 8
   Case fdAllerheiligen
      d = 1
      m = 11
   Case fdHeiligabend
      d = 24
      m = 12
   Case fdWeihnachten
      d = 25
      m = 12
   Case fdWeihnachten2
      d = 26
      m = 12
   Case fdSilvester
      d = 31
      m = 12
   Case Else
      Exit Function
   End Select
   
   DateOfFix = DateSerial(Y, m, d)
End Function

Public Property Get NameOfFix(ByVal f As EnumFixDays) As String
   NameOfFix = m_NamesOfFix(f)
End Property

Public Property Get NameOf(ByVal d As EnumCalendarDays) As String
   NameOf = m_NamesOfDays(d)
End Property

Public Property Get LevelOf(ByVal d As EnumCalendarDays) As EnumValid
   LevelOf = m_Level(d)
End Property

Public Property Get LevelOfFix(ByVal d As EnumFixDays) As EnumValid
   LevelOfFix = m_LevelFix(d)
End Property

Public Property Get DateOf(ByVal d As EnumCalendarDays) As Date
   DateOf = m_Days(d)
End Property

Public Property Get DateAndNameOf(ByVal d As EnumCalendarDays) As String
   DateAndNameOf = Format$(m_Days(d), mc_FormatDay) & vbTab & m_NamesOfDays(d)
End Property

Private Function EasterDate(ByVal Y As Integer) As Date
'the EasterDate function was found here: http://www.assa.org.au/edm.html#Computer
' EASTER DATE CALCULATION FOR YEARS 1583 TO 4099

' y is a 4 digit year 1583 to 4099
' d returns the day of the month of Easter
' m returns the month of Easter

' Easter Sunday is the Sunday following the Paschal Full Moon
' (PFM) date for the year

' This algorithm is an arithmetic interpretation of the 3 step
' Easter Dating Method developed by Ron Mallen 1985, as a vast
' improvement on the method described in the Common Prayer Book

' Because this algorithm is a direct translation of the
' official tables, it can be easily proved to be 100% correct

' This algorithm derives values by sequential inter-dependent
' calculations, so ... DO NOT MODIFY THE ORDER OF CALCULATIONS!

' The \ operator may be unfamiliar - it means integer division
' for example, 30 \ 7 = 4 (the remainder is ignored)

' All variables are integer data types
' It's free!  Please do not modify code or comments!

   Dim m As Integer, d As Integer
   Dim FirstDig As Integer, Remain19 As Integer, temp As Integer    'intermediate results
   Dim tA As Integer, tB As Integer, tC As Integer, tD As Integer, tE As Integer 'table A to E results

   FirstDig = Y \ 100      'first 2 digits of year
   Remain19 = Y Mod 19     'remainder of year / 19
   
'calculate PFM date
   temp = (FirstDig - 15) \ 2 + 202 - 11 * Remain19
   If FirstDig > 26 Then temp = temp - 1
   If FirstDig > 38 Then temp = temp - 1
   
   'this next line uses underscore (_) line continuation characters
   'in older versions of VB you may need to revert to one long line
   If ((FirstDig = 21) Or (FirstDig = 24) Or (FirstDig = 25) _
        Or (FirstDig = 33) Or (FirstDig = 36) Or (FirstDig = 37)) _
        Then temp = temp - 1
   
   temp = temp Mod 30

   tA = temp + 21
   If temp = 29 Then tA = tA - 1
   If (temp = 28 And Remain19 > 10) Then tA = tA - 1
        
'find the next Sunday
   tB = (tA - 19) Mod 7
   tC = (40 - FirstDig) Mod 4
   If tC = 3 Then tC = tC + 1
   If tC > 1 Then tC = tC + 1
   temp = Y Mod 100
   tD = (temp + temp \ 4) Mod 7
   tE = ((20 - tB - tC - tD) Mod 7) + 1
   d = tA + tE

'return the date
   If d > 31 Then
      d = d - 31
      m = 4
   Else
      m = 3
   End If
  
   EasterDate = CDate(Format$(CStr(m) + "/" + CStr(d) + "/" + CStr(Y), "mm/dd/yyyy"))
End Function

Private Function AdventDate(ByVal Y As Integer) As Date
'Advent: Beginn des Kirchenjahres.
'1. Advent = 1. Sonntag nchst St. Andreas (30. November)
'Bu- und Bettag = 1. Advent - 10 Tage
  Dim StAndrewsDay As Date
  
  StAndrewsDay = CDate(Format$("11/30/" + Str(Y), "mm/dd/yyyy"))
  
  Select Case Weekday(StAndrewsDay)
    Case 5, 6, 7  'thu, fri, sat
      AdventDate = StAndrewsDay + (8 - Weekday(StAndrewsDay))
    Case 1        'sun
      AdventDate = StAndrewsDay
    Case 2, 3, 4  'mon, tue, wed
      AdventDate = StAndrewsDay - (Weekday(StAndrewsDay) - 1)
  End Select
End Function



