VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CReg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Lesen, Schreiben und Lschen von Registry-Eintrngen
'in 'Local_Machine' und 'Current_User'.
'Lesen und Schreiben nur im Zweig 'Software/<Company>/<Application>'.
'Alle Eintrge werden als String behandelt.

'Methoden (public)
'-GetKeyLM          Argument: Schlssel (String)
'                   Rckgabe: Wert zu Schlssel aus 'Local_Machine'
'-GetKeyCU          Argument: Schlssel (String)
'                   Rckgabe: Wert zu Schlssel aus 'Current_User'
'-SetKeyLM          Argumente: Schlssel (String), Wert (String)
'                   setzt Wert zu Schlssel unter 'Local_Machine'
'-SetKeyCU          Argumente: Schlssel (String), Wert (String)
'                   setzt Wert zu Schlssel unter 'Current_User'


Option Explicit

Private Const mc_Company As String = "TrappDV"
Private Const mc_App As String = "ClndFunc"

'Registry API Declarations...
Private Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByRef lpSecurityAttributes As SECURITY_ATTRIBUTES, ByRef phkResult As Long, ByRef lpdwDisposition As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, ByRef phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, ByRef lpType As Long, ByVal lpData As String, ByRef lpcbData As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long

'Reg Data Types...
Private Const REG_SZ = 1                    'Unicode nul terminated string
Private Const REG_EXPAND_SZ = 2             'Unicode nul terminated string
Private Const REG_DWORD = 4                 '32-bit number

'Reg Create Type Values...
Private Const REG_OPTION_NON_VOLATILE = 0   'Key is preserved when system is rebooted

'Reg Key Security Options...
Private Const READ_CONTROL = &H20000
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const KEY_READ = KEY_QUERY_VALUE + KEY_ENUMERATE_SUB_KEYS + KEY_NOTIFY + READ_CONTROL
Private Const KEY_WRITE = KEY_SET_VALUE + KEY_CREATE_SUB_KEY + READ_CONTROL
Private Const KEY_EXECUTE = KEY_READ
Private Const KEY_ALL_ACCESS = KEY_QUERY_VALUE + KEY_SET_VALUE + KEY_CREATE_SUB_KEY + KEY_ENUMERATE_SUB_KEYS + KEY_NOTIFY + KEY_CREATE_LINK + READ_CONTROL

'Reg Key ROOT Types...
Private Const HKEY_CURRENT_USER = &H80000001
Private Const HKEY_LOCAL_MACHINE = &H80000002

'Return Value...
Private Const ERROR_BADKEY = 2
Private Const ERROR_ACCESS_DENIED = 8
Private Const ERROR_SUCCESS = 0

'Registry Security Attributes TYPE...
Private Type SECURITY_ATTRIBUTES
   nLength As Long
   lpSecurityDescriptor As Long
   bInheritHandle As Boolean
End Type

'Lesen Schlsselwert: Local_Machine\Software\<Company>\<App>\*Key*
Public Function GetKeyLM(Key As String) As String
   GetKeyLM = sGetRegKey(HKEY_LOCAL_MACHINE, Key)
End Function

'Lesen Schlsselwert: CurrentUser\Software\<Company>\<App>\*Key*
Public Function GetKeyCU(Key As String) As String
   GetKeyCU = sGetRegKey(HKEY_CURRENT_USER, Key)
End Function

'Schreiben Schlsselwert: Local_Machine\Software\<Company>\<App>\*Key* = *Val*
Public Sub SetKeyLM(Key As String, ByVal Val As Variant)
   Call bSetRegKey(HKEY_LOCAL_MACHINE, Key, CStr(Val))
End Sub

'Schreiben Schlsselwert (fr Anwendung): CurrentUser\Software\<Company>\<App>\*Key* = *Val*
Public Sub SetKeyCU(Key As String, ByVal Val As String)
   Call bSetRegKey(HKEY_CURRENT_USER, Key, CStr(Val))
End Sub

'Lesen Schlsselwert
Private Function sGetRegKey(hKey As Long, ByVal sKey As String) As String
On Error GoTo Err_
   Dim iKey As Long
   Dim iLen As Long
   Dim iDt  As Long
   Dim sGet As String
   Dim sVal As String
   Dim sSection As String
   
   sSection = "SOFTWARE\" & mc_Company & "\" & mc_App
   iLen = 255
   
   If RegOpenKeyEx(hKey, sSection, ByVal 0&, KEY_QUERY_VALUE, iKey) = ERROR_SUCCESS Then

      sVal = String(iLen, 0)
      
      iDt = REG_SZ
      If RegQueryValueEx(iKey, sKey, ByVal 0&, iDt, ByVal sVal, iLen) = ERROR_SUCCESS Then
          sGet = Left$(sVal, iLen)
      End If
      RegCloseKey (iKey)
   End If
   
   If Len(sGet) > 0 Then
      If Asc(Right$(sGet, 1)) = 0 Then sGet = Left$(sGet, Len(sGet) - 1)
   End If
   
   sGet = Trim$(sGet)
   
   sGetRegKey = sGet
   Exit Function
Err_:
End Function

'Schreiben Schlsselwert
'nur mglich fr ...\Software\<Company>\<App>\...
Private Function bSetRegKey(hKeyRoot As Long, _
                            ByVal sKey As String, _
                            ByVal sVal As String) As Boolean
   Dim sSection As String
   Dim iReturn  As Long
   Dim hDepth   As Long
   Dim hKey     As Long                 'Handle To A Registry Key
   Dim lpAttr   As SECURITY_ATTRIBUTES  'Registry Security Type
      
'Security Attributes Defaults ...
   lpAttr.nLength = 50                 'bei neuer Windowsversion berprfen!
   lpAttr.lpSecurityDescriptor = 0
   lpAttr.bInheritHandle = True
   
   sSection = "SOFTWARE\" & mc_Company & "\" & mc_App
   
'Create/Open Registry Key... //hKeyRoot//sKey
   iReturn = RegCreateKeyEx(hKeyRoot, sSection, 0, REG_SZ, REG_OPTION_NON_VOLATILE, KEY_WRITE, lpAttr, hKey, hDepth)
   If (iReturn <> ERROR_SUCCESS) Then GoTo Err_
'Create/Modify Key Value...
   If Len(sVal) = 0 Then sVal = " "  'A Space Is Needed for RegSetValueEx()
'Create/Modify Key Value
   iReturn = RegSetValueEx(hKey, sKey, 0, REG_SZ, sVal, LenB(StrConv(sVal, vbFromUnicode)))
   If (iReturn <> ERROR_SUCCESS) Then GoTo Err_
   iReturn = RegCloseKey(hKey)
   bSetRegKey = True
   Exit Function
Err_:
   iReturn = RegCloseKey(hKey)       'Attempt To Close Key
End Function
