VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cYearLimits"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim m_Min     As Integer
Dim m_Max     As Integer
Dim m_Begin   As Integer
Dim m_End     As Integer

Dim m_Changed As Boolean

Private Sub Class_Initialize()
   Dim oReg As CReg
   Dim oCD  As cClndFunc
   
   Set oReg = New CReg
   m_Begin = Val(oReg.GetKeyLM("Begin"))
   m_End = Val(oReg.GetKeyLM("End"))
   Set oReg = Nothing
   
   Set oCD = New cClndFunc
   m_Min = oCD.MinYear
   m_Max = oCD.MaxYear
   Set oCD = Nothing
   
   CheckYears
End Sub

Private Sub CheckYears()
   If m_Begin < m_Min Then
      m_Begin = m_Min
      m_Changed = True
   End If
   
   If m_Begin > (Year(Date) \ 10) * 10 Then
      m_Begin = StandardLower
      m_Changed = True
   End If
   
   If m_End < (Year(Date) \ 10 + 1) * 10 Then
      m_End = StandardUpper
      m_Changed = True
   End If

   If m_End > m_Max Then
      m_End = m_Max
      m_Changed = True
   End If
End Sub

Public Property Get Changed() As Boolean
   Changed = m_Changed
End Property

Public Property Get FirstYear() As Integer
   FirstYear = m_Begin
End Property

Public Property Let FirstYear(ByVal NewValue As Integer)
   If m_Begin = NewValue Then Exit Property
   m_Begin = NewValue
   m_Changed = True
   CheckYears
End Property

Public Property Get LastYear() As Integer
   LastYear = m_End
End Property

Public Property Let LastYear(ByVal NewValue As Integer)
   If m_End = NewValue Then Exit Property
   m_End = NewValue
   m_Changed = True
   CheckYears
End Property

Public Property Get StandardLower() As Integer
   StandardLower = ((Year(Date) + 50) \ 100 - 1) * 100
End Property

Public Property Get MinYear() As Integer
   MinYear = m_Min
End Property

Public Property Get StandardUpper() As Integer
   StandardUpper = ((Year(Date) + 50) \ 100 + 1) * 100
End Property

Public Property Get MaxYear() As Integer
   MaxYear = m_Max
End Property

Public Sub Update()
   Dim oReg As New CReg
   
   oReg.SetKeyLM "Begin", CStr(m_Begin)
   oReg.SetKeyLM "End", CStr(m_End)
   m_Changed = False
End Sub

Private Sub Class_Terminate()
   If m_Changed Then Update
End Sub
